#include <bits/stdc++.h>
using namespace std;
vector<int> X;
vector<int> Y;
using ll = long long;

int main() {
    int n, k, t; cin >> n >> k >> t;
    vector<vector<int>> G(n);
    for(int i = 0; i < n-1; ++i){
        int u, v; cin >> u >> v;
        G[u-1].push_back(v-1);
        G[v-1].push_back(u-1);
    }
    int ans = 1000000000;
    if(t == 0) {
        for(int hh = 1; hh < n; ++hh){
            G[0].push_back(hh);
            int INF = 1000000000;
            vector<int> dist(n, INF);
            dist[0] = 0;
            dist[hh] = 1;
            queue<int> q;
            q.push(0);
            vector<int> used(n, 0);
            used[hh] = 1;
            while (!q.empty()) {
                int v = q.front();
                used[v] = 1;
                for (int u: G[v]) {
                    dist[u] = min(dist[u], dist[v] + 1);
                    if (used[u] == 0) {
                        q.push(u);
                    }
                }
                q.pop();
            }
            int res = 0;
            for (int i = 0; i < n; ++i) {
                res = max(res, dist[i]);
            }
            ans = min(ans, res);
            G[0].pop_back();
        }
        cout << ans;
    }
}
