#include <bits/stdc++.h>
using namespace std;

using ll = long long;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, k, t; cin >> n >> k >> t;
    vector<vector<int>> G(n);
    for(int i = 0; i < n-1; ++i){
        int u, v; cin >> u >> v;
        G[u-1].push_back(v-1);
        G[v-1].push_back(u-1);
    }
    int ans = 1000000000;
    if(t == 0) {
        int INF = 1000000000;
        vector<int> dist(n, INF);
        dist[0] = 0;
        queue<int> q;
        q.push(0);
        vector<int> used(n, 0);
        while (!q.empty()) {
            int v = q.front();
            used[v] = 1;
            for (int u: G[v]) {
                dist[u] = min(dist[u], dist[v] + 1);
                if(used[u] == 0){
                    q.push(u);
                }
            }
            q.pop();
        }
        for(int hh = 1; hh < n; ++hh){
            int l = dist[hh];
            vector<int> dist1(n, INF);
            dist1[hh] = 1;
            vector<int> used1(n, 0);
            q.push(hh);
            while (!q.empty()) {
                int v = q.front();
                used1[v] = 1;
                for (int u: G[v]) {
                    if(dist[u] > l){
                        dist1[u] = min(dist1[u], dist1[v] + 1);
                        if (used1[u] == 0) {
                            q.push(u);
                        }
                    }
                }
                q.pop();
            }
            int res = 0;
            for (int i = 0; i < n; ++i) {
                if(dist1[i] != INF){
                    res = max(res, dist1[i]);
                }else{
                    res = max(res, dist[i]);
                }
            }
            ans = min(ans, res);
        }
        cout << ans;
    }
}